﻿using System.Windows;
using System.ComponentModel;
using Telerik.Windows.Controls;
using System.Windows.Controls;
using System;
using Telerik.Windows.Documents.RichTextBoxCommands.CommandEventArgs;
using System.Collections.Generic;
using Telerik.Windows.Documents.Model;
using System.Windows.Input;
using Telerik.Windows.Controls.RichTextBoxUI;
using System.Reflection;

namespace AM.Common.UI
{
	/// <summary>
	/// Redo derivative of the Telerik <c>MultipleUndoControl</c>.
	/// </summary>
	public class MultipleRedoControl : MultipleUndoControl
	{
		/// <summary>
		/// Initializes a new instance of the <see cref="MultipleRedoControl"/> class.
		/// </summary>
		public MultipleRedoControl()
		{
			Type t = this.GetType().BaseType;

			RadRibbonToggleButton[] actionButtons = t.InvokeMember("actionButtons", BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.GetField, null,
				this as MultipleUndoControl, null) as RadRibbonToggleButton[];

			foreach (RadRibbonToggleButton btn in actionButtons)
			{
				btn.MouseEnter+=new MouseEventHandler(RadButton_MouseEnter);
			}

		}

		private void RadButton_MouseEnter(object sender, MouseEventArgs e)
		{
			RadRibbonToggleButton button = sender as RadRibbonToggleButton;
			if (button != null)
			{
				Type t = this.GetType().BaseType;

				RadRibbonToggleButton[] actionButtons = t.InvokeMember("actionButtons", BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.GetField, null,
					this as MultipleUndoControl, null) as RadRibbonToggleButton[];

				int i = 0;
				while (i < (int)actionButtons.Length)
				{
					if (actionButtons[i] != button)
					{
						i++;
					}
					else
					{
						this.FillMultipleUndoActionsContent(i);
						break;
					}
				}
			}
		}

		private void FillMultipleUndoActionsContent(int index)
		{
			Type t = this.GetType().BaseType;

			RadButton btn = t.InvokeMember("textBlockMultipleUndoActionsContent", BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.GetField, null,
				this as MultipleUndoControl, null) as RadButton;

			index++;
			object[] str = new object[4];
			str[0] = "Redo";
			str[1] = " ";
			str[2] = index;
			str[3] = " ";
			btn.Content = string.Concat(str);
			if (index <= 1)
			{
				btn.Content = string.Concat(btn.Content, LocalizationManager.GetString("Documents_MultipleUndoControl_Action"));
			}
			else
			{
				btn.Content = string.Concat(btn.Content, LocalizationManager.GetString("Documents_MultipleUndoControl_Actions"));
			}
		}
	}
}
